// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marker_msgs:msg/Marker.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER__STRUCT_H_
#define MARKER_MSGS__MSG__DETAIL__MARKER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'ids'
// Member 'ids_confidence'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in msg/Marker in the package marker_msgs.
/**
  * This expresses a marker/fiducial in a 3D space
 */
typedef struct marker_msgs__msg__Marker
{
  /// possible ids of the detected fiducial (empty if no id could be identified)
  rosidl_runtime_c__int32__Sequence ids;
  /// confidence of the possible ids in [0, 1]
  rosidl_runtime_c__double__Sequence ids_confidence;
  /// pose of the detected marker/fiducial
  geometry_msgs__msg__Pose pose;
} marker_msgs__msg__Marker;

// Struct for a sequence of marker_msgs__msg__Marker.
typedef struct marker_msgs__msg__Marker__Sequence
{
  marker_msgs__msg__Marker * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marker_msgs__msg__Marker__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER__STRUCT_H_
