// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marker_msgs:msg/MarkerDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_H_
#define MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'view_direction'
#include "geometry_msgs/msg/detail/quaternion__struct.h"
// Member 'type'
#include "rosidl_runtime_c/string.h"
// Member 'markers'
#include "marker_msgs/msg/detail/marker__struct.h"

/// Struct defined in msg/MarkerDetection in the package marker_msgs.
/**
  * This expresses a marker/fiducial detection
 */
typedef struct marker_msgs__msg__MarkerDetection
{
  /// timestamp in the header is the acquisition time and frame
  std_msgs__msg__Header header;
  /// distance minimum range value
  float distance_min;
  /// distance maximum range value
  float distance_max;
  /// distance maximum range value to detect id
  /// not used for markers without id
  float distance_max_id;
  /// view direction
  geometry_msgs__msg__Quaternion view_direction;
  /// field of view horizontal
  float fov_horizontal;
  /// field of view vertical
  float fov_vertical;
  /// marker type used (bch, artag, mip_36h12, reflectors, stage, ...)
  rosidl_runtime_c__String type;
  /// detected markers
  marker_msgs__msg__Marker__Sequence markers;
} marker_msgs__msg__MarkerDetection;

// Struct for a sequence of marker_msgs__msg__MarkerDetection.
typedef struct marker_msgs__msg__MarkerDetection__Sequence
{
  marker_msgs__msg__MarkerDetection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marker_msgs__msg__MarkerDetection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_H_
