// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marker_msgs:msg/MarkerWithCovariance.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_H_
#define MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'marker'
#include "marker_msgs/msg/detail/marker__struct.h"

/// Struct defined in msg/MarkerWithCovariance in the package marker_msgs.
/**
  * This expresses a marker in free space with uncertainty.
 */
typedef struct marker_msgs__msg__MarkerWithCovariance
{
  marker_msgs__msg__Marker marker;
  /// Row-major representation of the 6x6 covariance matrix
  /// The orientation parameters use a fixed-axis representation.
  /// In order, the parameters are:
  /// (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
  double covariance[36];
} marker_msgs__msg__MarkerWithCovariance;

// Struct for a sequence of marker_msgs__msg__MarkerWithCovariance.
typedef struct marker_msgs__msg__MarkerWithCovariance__Sequence
{
  marker_msgs__msg__MarkerWithCovariance * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marker_msgs__msg__MarkerWithCovariance__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_H_
