// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from marker_msgs:msg/MarkerWithCovarianceArray.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE_ARRAY__FUNCTIONS_H_
#define MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "marker_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marker_msgs/msg/detail/marker_with_covariance_array__struct.h"

/// Initialize msg/MarkerWithCovarianceArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marker_msgs__msg__MarkerWithCovarianceArray
 * )) before or use
 * marker_msgs__msg__MarkerWithCovarianceArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__init(marker_msgs__msg__MarkerWithCovarianceArray * msg);

/// Finalize msg/MarkerWithCovarianceArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
void
marker_msgs__msg__MarkerWithCovarianceArray__fini(marker_msgs__msg__MarkerWithCovarianceArray * msg);

/// Create msg/MarkerWithCovarianceArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marker_msgs__msg__MarkerWithCovarianceArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
marker_msgs__msg__MarkerWithCovarianceArray *
marker_msgs__msg__MarkerWithCovarianceArray__create();

/// Destroy msg/MarkerWithCovarianceArray message.
/**
 * It calls
 * marker_msgs__msg__MarkerWithCovarianceArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
void
marker_msgs__msg__MarkerWithCovarianceArray__destroy(marker_msgs__msg__MarkerWithCovarianceArray * msg);

/// Check for msg/MarkerWithCovarianceArray message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__are_equal(const marker_msgs__msg__MarkerWithCovarianceArray * lhs, const marker_msgs__msg__MarkerWithCovarianceArray * rhs);

/// Copy a msg/MarkerWithCovarianceArray message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__copy(
  const marker_msgs__msg__MarkerWithCovarianceArray * input,
  marker_msgs__msg__MarkerWithCovarianceArray * output);

/// Initialize array of msg/MarkerWithCovarianceArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * marker_msgs__msg__MarkerWithCovarianceArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__init(marker_msgs__msg__MarkerWithCovarianceArray__Sequence * array, size_t size);

/// Finalize array of msg/MarkerWithCovarianceArray messages.
/**
 * It calls
 * marker_msgs__msg__MarkerWithCovarianceArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
void
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__fini(marker_msgs__msg__MarkerWithCovarianceArray__Sequence * array);

/// Create array of msg/MarkerWithCovarianceArray messages.
/**
 * It allocates the memory for the array and calls
 * marker_msgs__msg__MarkerWithCovarianceArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
marker_msgs__msg__MarkerWithCovarianceArray__Sequence *
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__create(size_t size);

/// Destroy array of msg/MarkerWithCovarianceArray messages.
/**
 * It calls
 * marker_msgs__msg__MarkerWithCovarianceArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
void
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__destroy(marker_msgs__msg__MarkerWithCovarianceArray__Sequence * array);

/// Check for msg/MarkerWithCovarianceArray message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__are_equal(const marker_msgs__msg__MarkerWithCovarianceArray__Sequence * lhs, const marker_msgs__msg__MarkerWithCovarianceArray__Sequence * rhs);

/// Copy an array of msg/MarkerWithCovarianceArray messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
bool
marker_msgs__msg__MarkerWithCovarianceArray__Sequence__copy(
  const marker_msgs__msg__MarkerWithCovarianceArray__Sequence * input,
  marker_msgs__msg__MarkerWithCovarianceArray__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE_ARRAY__FUNCTIONS_H_
