// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marker_msgs:msg/Fiducial.idl
// generated code does not contain a copyright notice
#include "marker_msgs/msg/detail/fiducial__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ids`
// Member `ids_confidence`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `object_points`
// Member `image_points`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
marker_msgs__msg__Fiducial__init(marker_msgs__msg__Fiducial * msg)
{
  if (!msg) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->ids, 0)) {
    marker_msgs__msg__Fiducial__fini(msg);
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__init(&msg->ids_confidence, 0)) {
    marker_msgs__msg__Fiducial__fini(msg);
    return false;
  }
  // object_points
  if (!geometry_msgs__msg__Point__Sequence__init(&msg->object_points, 0)) {
    marker_msgs__msg__Fiducial__fini(msg);
    return false;
  }
  // image_points
  if (!geometry_msgs__msg__Point__Sequence__init(&msg->image_points, 0)) {
    marker_msgs__msg__Fiducial__fini(msg);
    return false;
  }
  return true;
}

void
marker_msgs__msg__Fiducial__fini(marker_msgs__msg__Fiducial * msg)
{
  if (!msg) {
    return;
  }
  // ids
  rosidl_runtime_c__int32__Sequence__fini(&msg->ids);
  // ids_confidence
  rosidl_runtime_c__double__Sequence__fini(&msg->ids_confidence);
  // object_points
  geometry_msgs__msg__Point__Sequence__fini(&msg->object_points);
  // image_points
  geometry_msgs__msg__Point__Sequence__fini(&msg->image_points);
}

bool
marker_msgs__msg__Fiducial__are_equal(const marker_msgs__msg__Fiducial * lhs, const marker_msgs__msg__Fiducial * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->ids), &(rhs->ids)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->ids_confidence), &(rhs->ids_confidence)))
  {
    return false;
  }
  // object_points
  if (!geometry_msgs__msg__Point__Sequence__are_equal(
      &(lhs->object_points), &(rhs->object_points)))
  {
    return false;
  }
  // image_points
  if (!geometry_msgs__msg__Point__Sequence__are_equal(
      &(lhs->image_points), &(rhs->image_points)))
  {
    return false;
  }
  return true;
}

bool
marker_msgs__msg__Fiducial__copy(
  const marker_msgs__msg__Fiducial * input,
  marker_msgs__msg__Fiducial * output)
{
  if (!input || !output) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->ids), &(output->ids)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->ids_confidence), &(output->ids_confidence)))
  {
    return false;
  }
  // object_points
  if (!geometry_msgs__msg__Point__Sequence__copy(
      &(input->object_points), &(output->object_points)))
  {
    return false;
  }
  // image_points
  if (!geometry_msgs__msg__Point__Sequence__copy(
      &(input->image_points), &(output->image_points)))
  {
    return false;
  }
  return true;
}

marker_msgs__msg__Fiducial *
marker_msgs__msg__Fiducial__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Fiducial * msg = (marker_msgs__msg__Fiducial *)allocator.allocate(sizeof(marker_msgs__msg__Fiducial), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marker_msgs__msg__Fiducial));
  bool success = marker_msgs__msg__Fiducial__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marker_msgs__msg__Fiducial__destroy(marker_msgs__msg__Fiducial * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marker_msgs__msg__Fiducial__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marker_msgs__msg__Fiducial__Sequence__init(marker_msgs__msg__Fiducial__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Fiducial * data = NULL;

  if (size) {
    data = (marker_msgs__msg__Fiducial *)allocator.zero_allocate(size, sizeof(marker_msgs__msg__Fiducial), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marker_msgs__msg__Fiducial__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marker_msgs__msg__Fiducial__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marker_msgs__msg__Fiducial__Sequence__fini(marker_msgs__msg__Fiducial__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marker_msgs__msg__Fiducial__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marker_msgs__msg__Fiducial__Sequence *
marker_msgs__msg__Fiducial__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Fiducial__Sequence * array = (marker_msgs__msg__Fiducial__Sequence *)allocator.allocate(sizeof(marker_msgs__msg__Fiducial__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marker_msgs__msg__Fiducial__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marker_msgs__msg__Fiducial__Sequence__destroy(marker_msgs__msg__Fiducial__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marker_msgs__msg__Fiducial__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marker_msgs__msg__Fiducial__Sequence__are_equal(const marker_msgs__msg__Fiducial__Sequence * lhs, const marker_msgs__msg__Fiducial__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marker_msgs__msg__Fiducial__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marker_msgs__msg__Fiducial__Sequence__copy(
  const marker_msgs__msg__Fiducial__Sequence * input,
  marker_msgs__msg__Fiducial__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marker_msgs__msg__Fiducial);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marker_msgs__msg__Fiducial * data =
      (marker_msgs__msg__Fiducial *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marker_msgs__msg__Fiducial__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marker_msgs__msg__Fiducial__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marker_msgs__msg__Fiducial__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
