// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marker_msgs:msg/Marker.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER__TRAITS_HPP_
#define MARKER_MSGS__MSG__DETAIL__MARKER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marker_msgs/msg/detail/marker__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace marker_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Marker & msg,
  std::ostream & out)
{
  out << "{";
  // member: ids
  {
    if (msg.ids.size() == 0) {
      out << "ids: []";
    } else {
      out << "ids: [";
      size_t pending_items = msg.ids.size();
      for (auto item : msg.ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ids_confidence
  {
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []";
    } else {
      out << "ids_confidence: [";
      size_t pending_items = msg.ids_confidence.size();
      for (auto item : msg.ids_confidence) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Marker & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids.size() == 0) {
      out << "ids: []\n";
    } else {
      out << "ids:\n";
      for (auto item : msg.ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ids_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []\n";
    } else {
      out << "ids_confidence:\n";
      for (auto item : msg.ids_confidence) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Marker & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marker_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marker_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marker_msgs::msg::Marker & msg,
  std::ostream & out, size_t indentation = 0)
{
  marker_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marker_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marker_msgs::msg::Marker & msg)
{
  return marker_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marker_msgs::msg::Marker>()
{
  return "marker_msgs::msg::Marker";
}

template<>
inline const char * name<marker_msgs::msg::Marker>()
{
  return "marker_msgs/msg/Marker";
}

template<>
struct has_fixed_size<marker_msgs::msg::Marker>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marker_msgs::msg::Marker>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marker_msgs::msg::Marker>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER__TRAITS_HPP_
