// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marker_msgs:msg/MarkerDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__TRAITS_HPP_
#define MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marker_msgs/msg/detail/marker_detection__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'view_direction'
#include "geometry_msgs/msg/detail/quaternion__traits.hpp"
// Member 'markers'
#include "marker_msgs/msg/detail/marker__traits.hpp"

namespace marker_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MarkerDetection & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: distance_min
  {
    out << "distance_min: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_min, out);
    out << ", ";
  }

  // member: distance_max
  {
    out << "distance_max: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_max, out);
    out << ", ";
  }

  // member: distance_max_id
  {
    out << "distance_max_id: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_max_id, out);
    out << ", ";
  }

  // member: view_direction
  {
    out << "view_direction: ";
    to_flow_style_yaml(msg.view_direction, out);
    out << ", ";
  }

  // member: fov_horizontal
  {
    out << "fov_horizontal: ";
    rosidl_generator_traits::value_to_yaml(msg.fov_horizontal, out);
    out << ", ";
  }

  // member: fov_vertical
  {
    out << "fov_vertical: ";
    rosidl_generator_traits::value_to_yaml(msg.fov_vertical, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: markers
  {
    if (msg.markers.size() == 0) {
      out << "markers: []";
    } else {
      out << "markers: [";
      size_t pending_items = msg.markers.size();
      for (auto item : msg.markers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MarkerDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: distance_min
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_min: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_min, out);
    out << "\n";
  }

  // member: distance_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_max: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_max, out);
    out << "\n";
  }

  // member: distance_max_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_max_id: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_max_id, out);
    out << "\n";
  }

  // member: view_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "view_direction:\n";
    to_block_style_yaml(msg.view_direction, out, indentation + 2);
  }

  // member: fov_horizontal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fov_horizontal: ";
    rosidl_generator_traits::value_to_yaml(msg.fov_horizontal, out);
    out << "\n";
  }

  // member: fov_vertical
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fov_vertical: ";
    rosidl_generator_traits::value_to_yaml(msg.fov_vertical, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: markers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.markers.size() == 0) {
      out << "markers: []\n";
    } else {
      out << "markers:\n";
      for (auto item : msg.markers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MarkerDetection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marker_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marker_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marker_msgs::msg::MarkerDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  marker_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marker_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marker_msgs::msg::MarkerDetection & msg)
{
  return marker_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marker_msgs::msg::MarkerDetection>()
{
  return "marker_msgs::msg::MarkerDetection";
}

template<>
inline const char * name<marker_msgs::msg::MarkerDetection>()
{
  return "marker_msgs/msg/MarkerDetection";
}

template<>
struct has_fixed_size<marker_msgs::msg::MarkerDetection>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marker_msgs::msg::MarkerDetection>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marker_msgs::msg::MarkerDetection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__TRAITS_HPP_
