// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marker_msgs:msg/MarkerStamped.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_STAMPED__TRAITS_HPP_
#define MARKER_MSGS__MSG__DETAIL__MARKER_STAMPED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marker_msgs/msg/detail/marker_stamped__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'marker'
#include "marker_msgs/msg/detail/marker__traits.hpp"

namespace marker_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MarkerStamped & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: marker
  {
    out << "marker: ";
    to_flow_style_yaml(msg.marker, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MarkerStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: marker
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "marker:\n";
    to_block_style_yaml(msg.marker, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MarkerStamped & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marker_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marker_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marker_msgs::msg::MarkerStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  marker_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marker_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marker_msgs::msg::MarkerStamped & msg)
{
  return marker_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marker_msgs::msg::MarkerStamped>()
{
  return "marker_msgs::msg::MarkerStamped";
}

template<>
inline const char * name<marker_msgs::msg::MarkerStamped>()
{
  return "marker_msgs/msg/MarkerStamped";
}

template<>
struct has_fixed_size<marker_msgs::msg::MarkerStamped>
  : std::integral_constant<bool, has_fixed_size<marker_msgs::msg::Marker>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<marker_msgs::msg::MarkerStamped>
  : std::integral_constant<bool, has_bounded_size<marker_msgs::msg::Marker>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<marker_msgs::msg::MarkerStamped>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_STAMPED__TRAITS_HPP_
